/*!
 *  @preserve
 *  
 *  @module      iframe-resizer/jquery 5.2.5-beta.3 (umd) - 2024-08-20
 *
 *  @license     GPL-3.0 for non-commercial use only.
 *               For commercial use, you must purchase a license from
 *               https://iframe-resizer.com/pricing
 * 
 *  @description Keep same and cross domain iFrames sized to their content 
 *
 *  @author      David J. Bradshaw <info@iframe-resizer.com>
 * 
 *  @see         {@link https://iframe-resizer.com}
 * 
 *  @copyright  (c) 2013 - 2024, David J. Bradshaw. All rights reserved.
 */


!function(e){"function"==typeof define&&define.amd?define(e):e()}((function(){"use strict";const e="5.2.5-beta.3",i="[iFrameSizer]",t=i.length,n=Object.freeze({max:1,scroll:1,bodyScroll:1,documentElementScroll:1}),o=(e,i,t,n)=>e.addEventListener(i,t,n||!1),r=(e,i,t)=>e.removeEventListener(i,t,!1),a="[iframe-resizer]";let s={},l=!1;const c=e=>`${a}[${function(e){return window.top===window.self?`Parent page: ${e}`:window?.parentIFrame?.getId?`${window.parentIFrame.getId()}: ${e}`:`Nested parent page: ${e}`}(e)}]`,d=(e,i,...t)=>window?.console[e](c(i),...t),u=(e,...i)=>!0===(e=>s[e]?s[e].log:l)(e)?d("log",e,...i):null,f=(e,...i)=>d("warn",e,...i),p=(e,i)=>console?.warn((e=>i=>window.chrome?e(i.replaceAll("<br>","\n").replaceAll("<rb>","[31;1m").replaceAll("</>","[m").replaceAll("<b>","[1m").replaceAll("<i>","[3m").replaceAll("<u>","[4m")):e(i.replaceAll("<br>","\n").replaceAll(/<[/a-z]+>/gi,"")))((e=>(...i)=>[`${a}[${e}]`,...i].join(" "))(e))(i)),m=e=>{if(!e)return"";let i=-559038744,t=1103547984;for(let n,o=0;o<e.length;o++)n=e.codePointAt(o),i=Math.imul(i^n,2246822519),t=Math.imul(t^n,3266489917);return i^=Math.imul(i^t>>>15,1935289751),t^=Math.imul(t^i>>>15,3405138345),i^=t>>>16,t^=i>>>16,(2097152*(t>>>0)+(i>>>11)).toString(36)},h=e=>e.replaceAll(/[A-Za-z]/g,(e=>String.fromCodePoint((e<="Z"?90:122)>=(e=e.codePointAt(0)+19)?e:e-26))),g=["<iy><yi>Puchspk Spjluzl Rlf</><iy><iy>","<iy><yi>Tpzzpun Spjluzl Rlf</><iy><iy>","Aopz spiyhyf pz hchpshisl dpao ivao Jvttlyjphs huk Vwlu-Zvbyjl spjluzlz.<iy><iy><i>Jvttlyjphs Spjluzl</><iy>Mvy jvttlyjphs bzl, <p>pmyhtl-ylzpgly</> ylxbpylz h svd jvza vul aptl spjluzl mll. Mvy tvyl pumvythapvu cpzpa <b>oaawz://pmyhtl-ylzpgly.jvt/wypjpun</>.<iy><iy><i>Vwlu Zvbyjl Spjluzl</><iy>Pm fvb hyl bzpun aopz spiyhyf pu h uvu-jvttlyjphs vwlu zvbyjl wyvqlja aolu fvb jhu bzl pa mvy myll bukly aol alytz vm aol NWS C3 Spjluzl. Av jvumpyt fvb hjjlwa aolzl alytz, wslhzl zla aol <i>spjluzl</> rlf pu <p>pmyhtl-ylzpgly</> vwapvuz av <i>NWSc3</>.<iy><iy>Mvy tvyl pumvythapvu wslhzl zll: <b>oaawz://pmyhtl-ylzpgly.jvt/nws</>","<i>NWSc3 Spjluzl Clyzpvu</><iy><iy>Aopz clyzpvu vm <p>pmyhtl-ylzpgly</> pz ilpun bzlk bukly aol alytz vm aol <i>NWS C3</> spjluzl. Aopz spjluzl hssvdz fvb av bzl <p>pmyhtl-ylzpgly</> pu Vwlu Zvbyjl wyvqljaz, iba pa ylxbpylz fvby wyvqlja av il wbispj, wyvcpkl haaypibapvu huk il spjluzlk bukly clyzpvu 3 vy shaly vm aol NUB Nlulyhs Wbispj Spjluzl.<iy><iy>Pm fvb hyl bzpun aopz spiyhyf pu h uvu-vwlu zvbyjl wyvqlja vy dlizpal, fvb dpss ullk av wbyjohzl h svd jvza vul aptl jvttlyjphs spjluzl.<iy><iy>Mvy tvyl pumvythapvu cpzpa <b>oaawz://pmyhtl-ylzpgly.jvt/wypjpun</>."],y=["NWSc3","zvsv","wyv","ibzpulzz","vlt"],w=Object.fromEntries(["2cgs7fdf4xb","1c9ctcccr4z","1q2pc4eebgb","ueokt0969w","w2zxchhgqz","1umuxblj2e5"].map(((e,i)=>[e,Math.max(0,i-1)]))),b=e=>h(g[e]),v=e=>{const i=e[h("spjluzl")];if(!i)return-1;const t=i.split("-");let n=function(e=""){let i=-2;const t=m(h(e));return t in w&&(i=w[t]),i}(t[0]);return 0===n||(e=>e[2]===m(e[0]+e[1]))(t)||(n=-2),n},z={},$=Object.freeze({autoResize:!0,bodyBackground:null,bodyMargin:null,bodyPadding:null,checkOrigin:!0,direction:"vertical",inPageLinks:!1,heightCalculationMethod:"auto",id:"iFrameResizer",log:!1,license:void 0,mouseEvents:!0,offsetHeight:null,offsetWidth:null,postMessageTarget:null,sameDomain:!1,scrolling:!1,sizeHeight:!0,sizeWidth:!1,warningTimeout:5e3,tolerance:0,waitForLoad:!1,widthCalculationMethod:"auto",onClose:()=>!0,onClosed(){},onInit:!1,onMessage:null,onMouseEnter(){},onMouseLeave(){},onReady:e=>{"function"==typeof z[e.id].onInit&&(p(e.id,"\n[31;1mDeprecated Option[m\n\nThe [1monInit()[m function is deprecated and has been replaced with [1monReady()[m. It will be removed in a future version of iFrame Resizer.\n      "),z[e.id].onInit(e))},onResized(){},onScroll:()=>!0}),j={position:null,version:e};function k(n){function a(){W(H),M(P),A("onResized",H)}function s(e){if("border-box"!==e.boxSizing)return 0;return(e.paddingTop?parseInt(e.paddingTop,10):0)+(e.paddingBottom?parseInt(e.paddingBottom,10):0)}function l(e){if("border-box"!==e.boxSizing)return 0;return(e.borderTopWidth?parseInt(e.borderTopWidth,10):0)+(e.borderBottomWidth?parseInt(e.borderBottomWidth,10):0)}function c(e){return D.slice(D.indexOf(":")+7+e)}const d=(e,i)=>(t,n)=>{const o={};var r,a;r=function(){C(`Send ${e} (${t})`,`${e}:${i()}`,n)},o[a=n]||(r(),o[a]=requestAnimationFrame((()=>{o[a]=null})))},m=(e,i)=>()=>{const t=i=>()=>{z[s]?e(i,s):a()};function n(e,n){u(s,`${e} listeners for send${i}`),n(window,"scroll",t("scroll")),n(window,"resize",t("resize window"))}function a(){n("Remove ",r),l.disconnect(),c.disconnect()}const s=P,l=new ResizeObserver(t("page observed")),c=new ResizeObserver(t("iframe observed"));n("Add ",o),l.observe(document.body,{attributes:!0,childList:!0,subtree:!0}),c.observe(z[s].iframe,{attributes:!0,childList:!1,subtree:!1}),z[s]&&(z[s][`stop${i}`]=a)},h=e=>()=>{e in z[P]&&(z[P][e](),delete z[P][e])},g=d("pageInfo",(function(){const e=document.body.getBoundingClientRect(),i=H.iframe.getBoundingClientRect(),{scrollY:t,scrollX:n,innerHeight:o,innerWidth:r}=window,{clientHeight:a,clientWidth:s}=document.documentElement;return JSON.stringify({iframeHeight:i.height,iframeWidth:i.width,clientHeight:Math.max(a,o||0),clientWidth:Math.max(s,r||0),offsetTop:parseInt(i.top-e.top,10),offsetLeft:parseInt(i.left-e.left,10),scrollTop:t,scrollLeft:n,documentHeight:a,documentWidth:s,windowHeight:o,windowWidth:r})})),y=d("parentInfo",(function(){const{iframe:e}=H,{scrollWidth:i,scrollHeight:t}=document.documentElement,{width:n,height:o,offsetLeft:r,offsetTop:a,pageLeft:s,pageTop:l,scale:c}=window.visualViewport;return JSON.stringify({iframe:e.getBoundingClientRect(),document:{scrollWidth:i,scrollHeight:t},viewport:{width:n,height:o,offsetLeft:r,offsetTop:a,pageLeft:s,pageTop:l,scale:c}})})),w=m(g,"PageInfo"),b=m(y,"ParentInfo"),v=h("stopPageInfo"),$=h("stopParentInfo");function k(e){const i=e.getBoundingClientRect();return S(P),{x:Number(i.left)+Number(j.position.x),y:Number(i.top)+Number(j.position.y)}}function I(e){const i=e?k(H.iframe):{x:0,y:0};let t=((e,i)=>({x:e.width+i.x,y:e.height+i.y}))(H,i);u(P,`Reposition requested from iFrame (offset x:${i.x} y:${i.y})`),window.top===window.self?(j.position=t,L(P),u(P,"--")):window.parentIFrame?window.parentIFrame["scrollTo"+(e?"Offset":"")](t.x,t.y):f(P,"Unable to scroll to requested position, window.parentIFrame not found")}function L(e){const{x:i,y:t}=j.position,n=z[e]?.iframe;!1!==A("onScroll",{iframe:n,top:t,left:i,x:i,y:t})?M(e):x()}function E(e){let i={};if(0===H.width&&0===H.height){const e=c(9).split(":");i={x:e[1],y:e[0]}}else i={x:H.width,y:H.height};A(e,{iframe:H.iframe,screenX:Number(i.x),screenY:Number(i.y),type:H.type})}const A=(e,i)=>T(P,e,i);let D=n.data,H={},P=null;"[iFrameResizerChild]Ready"!==D?i===`${D}`.slice(0,t)&&D.slice(t).split(":")[0]in z?(H=function(){const e=D.slice(t).split(":"),i=e[1]?Number(e[1]):0,n=z[e[0]]?.iframe,o=getComputedStyle(n);return{iframe:n,id:e[0],height:i+s(o)+l(o),width:Number(e[2]),type:e[3],msg:e[4]}}(),P=H.id,P?(function(e){if(!z[e])throw new Error(`${H.type} No settings for ${e}. Message was: ${D}`)}(P),function(){const e=H.type in{true:1,false:1,undefined:1};return e&&u(P,"Ignoring init message from meta parent page"),e}()||(u(P,`Received: ${D}`),z[P].loaded=!0,function(){let e=!0;return null===H.iframe&&(f(P,`The iframe (${H.id}) was not found.`),e=!1),e}()&&function(){const{origin:e,sameDomain:i}=n;if(i)return!0;let t=z[P]?.checkOrigin;if(t&&"null"!=`${e}`&&!(t.constructor===Array?function(){let i=0,n=!1;for(u(P,`Checking connection is from allowed list of origins: ${t}`);i<t.length;i++)if(t[i]===e){n=!0;break}return n}():function(){const i=z[P]?.remoteHost;return u(P,`Checking connection is from: ${i}`),e===i}()))throw new Error(`Unexpected message received from: ${e} for ${H.iframe.id}. Message was: ${n.data}. This error can be disabled by setting the checkOrigin: false option or by providing of array of trusted domains.`);return!0}()&&function(){switch(z[P]?.firstRun&&z[P]&&(z[P].firstRun=!1),H.type){case"close":R(H.iframe);break;case"message":t=c(6),u(P,`onMessage passed: {iframe: ${H.iframe.id}, message: ${t}}`),A("onMessage",{iframe:H.iframe,message:JSON.parse(t)}),u(P,"--");break;case"mouseenter":E("onMouseEnter");break;case"mouseleave":E("onMouseLeave");break;case"autoResize":z[P].autoResize=JSON.parse(c(9));break;case"scrollBy":!function(){const e=H.width,i=H.height,t=window.parentIframe||window;u(P,`Scroll request received by parent: x: ${e} y: ${i}`),t.scrollBy(e,i)}();break;case"scrollTo":I(!1);break;case"scrollToOffset":I(!0);break;case"pageInfo":g("start",P),w();break;case"parentInfo":y("start",P),b();break;case"pageInfoStop":v();break;case"parentInfoStop":$();break;case"inPageLink":!function(e){const i=e.split("#")[1]||"",t=decodeURIComponent(i);let n=document.getElementById(t)||document.getElementsByName(t)[0];n?function(){const e=k(n);u(P,`Moving to in page link (#${i}) at x: ${e.x} y: ${e.y}`),j.position={x:e.x,y:e.y},L(P),window.location.hash=i,u(P,"--")}():window.top!==window.self?window.parentIFrame?window.parentIFrame.moveToAnchor(i):u(P,`In page link #${i} not found and window.parentIFrame not found`):u(P,`In page link #${i} not found`)}(c(9));break;case"title":!function(e,i){z[i]?.syncTitle&&(z[i].iframe.title=e,u(i,`Set title attribute to: ${e}`))}(H.msg,P);break;case"reset":F(H);break;case"init":a(),function(e){try{z[e].sameDomain=!!z[e]?.iframe?.contentWindow?.iframeChildListener}catch(i){z[e].sameDomain=!1}u(e,`sameDomain: ${z[e].sameDomain}`)}(P),(i=H.msg)!==e&&(void 0!==i?u(P,`Version mismatch (Child: ${i} !== Parent: ${e})`):p(P,"<rb>Legacy version detected in iframe</>\n\nDetected legacy version of child page script. It is recommended to update the page in the iframe to use <b>@iframe-resizer/child</>.\n\nSee <u>https://iframe-resizer.com/setup/#child-page-setup</> for more details.\n")),N=!0,A("onReady",H.iframe);break;default:if(0===H.width&&0===H.height)return void f(P,`Unsupported message received (${H.type}), this is likely due to the iframe containing a later version of iframe-resizer than the parent page`);if(0===H.width||0===H.height)return void u(P,"Ignoring message with 0 height or width");if(document.hidden)return void u(P,"Page hidden - ignored resize request");a()}var i,t}())):f("","iframeResizer received messageData without id, message was: ",D)):null!==P&&u(P,"Ignored:",D):Object.keys(z).forEach((e=>{z[e].mode>=0&&C("iFrame requested init",O(e),e)}))}function T(e,i,t){let n=null,o=null;if(z[e]){if(n=z[e][i],"function"!=typeof n)throw new TypeError(`${i} on iFrame[${e}] is not a function`);o=n(t)}return o}function I(e){const i=e.id;delete z[i]}function R(e){const i=e.id;if(!1!==T(i,"onClose",i)){u(i,`Removing iFrame: ${i}`);try{e.parentNode&&e.remove()}catch(e){f(i,e)}T(i,"onClosed",i),u(i,"--"),I(e)}else u(i,"Close iframe cancelled by onClose event")}function S(e){null===j.position&&(j.position={x:window.scrollX,y:window.scrollY},u(e,`Get page position: ${j.position.x}, ${j.position.y}`))}function x(){j.position=null}function M(e){null!==j.position&&(window.scrollTo(j.position.x,j.position.y),u(e,`Set page position: ${j.position.x}, ${j.position.y}`),x())}function F(e){u(e.id,"Size reset requested by "+("init"===e.type?"parent page":"child page")),S(e.id),W(e),C("reset","reset",e.id)}function W(e){const i=e.id;function t(t){const n=`${e[t]}px`;e.iframe.style[t]=n,u(i,`IFrame (${i}) ${t} set to ${n}`)}z[i].sizeHeight&&t("height"),z[i].sizeWidth&&t("width")}function C(e,t,n,o){z[n]&&(z[n]?.postMessageTarget?function(){const{postMessageTarget:o,targetOrigin:r}=z[n];if(z[n].sameDomain)try{return z[n].iframe.contentWindow.iframeChildListener(i+t),void u(n,`[${e}] Sending message to iframe[${n}] (${t}) via sameDomain`)}catch(e){u(n,"Same domain connection failed. Trying cross domain")}u(n,`[${e}] Sending message to iframe[${n}] (${t}) targetOrigin: ${r}`),o.postMessage(i+t,r)}():f(n,`[${e}] IFrame(${n}) not found`),o&&z[n]?.warningTimeout&&(z[n].msgTimeout=setTimeout((function(){if(void 0===z[n])return;const{waitForLoad:e}=z[n];z[n].loaded||z[n].loadErrorShown||(z[n].loadErrorShown=!0,p(n,`\n<rb>No response from iFrame</>\n            \nThe iframe (<i>${n}</>) has not responded within ${z[n].warningTimeout/1e3} seconds. Check <b>@iframe-resizer/child</> package has been loaded in the iframe.\n${e?"\nThe <b>waitForLoad</> option is currently set to <b>true</>. If the iframe loads before the JavaScript runs, this option will prevent <i>iframe-resizer</> from initialising. To disable this, set the <b>waitForLoad</> option to <b>false</>.  \n":""}\nThis message can be ignored if everything is working, or you can set the <b>warningTimeout</> option to a higher value or zero to suppress this warning.\n`))}),z[n].warningTimeout)))}function O(e){const i=z[e];return[e,"8",i.sizeWidth,i.log,"32",!0,i.autoResize,i.bodyMargin,i.heightCalculationMethod,i.bodyBackground,i.bodyPadding,i.tolerance,i.inPageLinks,"child",i.widthCalculationMethod,i.mouseEvents,i.offsetHeight,i.offsetWidth,i.sizeHeight,i.license,j.version,i.mode].join(":")}s=z;let L=0,N=!1,E=!1;const A=i=>t=>{function r(e){if(!e)return{};if("object"!=typeof e)throw new TypeError("Options is not an object");return("sizeWidth"in e||"sizeHeight"in e||"autoResize"in e)&&p(s,'<rb>Deprecated Option</>\n\nThe <b>sizeWidth</>, <b>sizeHeight</> and <b>autoResize</> options have been replaced with new <b>direction</> option which expects values of <i>"vertical"</>, <i>"horizontal"</> or <i>"horizontal"</>.\n'),e}function a(e){const i=z[e]?.iframe?.title;return""===i||void 0===i}const s=function(e){if(e&&"string"!=typeof e)throw new TypeError("Invalid id for iFrame. Expected String");var n;return""!==e&&e||(t.id=e=function(){let e=i?.id||$.id+L++;return null!==document.getElementById(e)&&(e+=L++),e}(),n=(i||{}).log,l=n,u(e,`Added missing iframe ID: ${e} (${t.src})`)),e}(t.id);return s in z&&"iFrameResizer"in t?f(s,"Ignored iFrame, already setup."):(function(e){var i,n;z[s]={iframe:t,firstRun:!0,remoteHost:t?.src.split("/").slice(0,3).join("/"),...$,...r(e),mode:v(e),syncTitle:a(s)},function(){if("horizontal"===z[s].direction)return z[s].sizeWidth=!0,z[s].sizeHeight=!1,void u(s,'Direction set to "horizontal"');if("none"===z[s].direction)return z[s].sizeWidth=!1,z[s].sizeHeight=!1,z[s].autoResize=!1,void u(s,'Direction set to "none"');if("vertical"!==z[s].direction)throw new TypeError(s,`Direction value of "${z[s].direction}" is not valid`);u(s,'Direction set to "vertical"')}(),(i=e?.offsetSize||e?.offset)&&("vertical"===z[s].direction?(z[s].offsetHeight=i,u(s,`Offset height set to ${i}`)):(z[s].offsetWidth=i,u(s,`Offset width set to ${i}`))),e?.offset&&p(s,"<rb>Deprecated option</>\n\n The <b>offset</> option has been renamed to <b>offsetSize</>. Use of the old name will be removed in a future version of <i>iframe-resizer</>."),null===z[s].postMessageTarget&&(z[s].postMessageTarget=t.contentWindow),z[s].targetOrigin=!0===z[s].checkOrigin?""===(n=z[s].remoteHost)||null!==n.match(/^(about:blank|javascript:|file:\/\/)/)?"*":n:"*"}(i),function(){const{mode:i}=z[s];i<0&&p("Parent",`${b(i+2)}${b(2)}`),E||i<0||(E=!0,((e,...i)=>{d("info",e,...i)})(`v${e} (${(e=>h(y[e]))(i)})`),i<1&&p("Parent",b(3)))}(),H(),function(){switch(u(s,`IFrame scrolling ${z[s]?.scrolling?"enabled":"disabled"} for ${s}`),t.style.overflow=!1===z[s]?.scrolling?"hidden":"auto",z[s]?.scrolling){case"omit":break;case!0:t.scrolling="yes";break;case!1:t.scrolling="no";break;default:t.scrolling=z[s]?z[s].scrolling:"no"}}(),function(){const{bodyMargin:e}=z[s];"number"!=typeof e&&"0"!==e||(z[s].bodyMargin=`${e}px`)}(),function(e){const{id:i}=t;-1!==z[i].mode&&-2!==z[i].mode&&(o(t,"load",(function(){C("iFrame.onload",`${e}:${N}`,i,!0),function(){const e=z[s]?.firstRun,i=z[s]?.heightCalculationMethod in n;!e&&i&&F({iframe:t,height:0,width:0,type:"init"})}()})),!1===z[i].waitForLoad&&C("init",`${e}:${N}`,i,!0))}(O(s)),function(){if(z[s]){const e={close:R.bind(null,z[s].iframe),disconnect:I.bind(null,z[s].iframe),removeListeners(){p(s,"\n<rb>Deprecated Method Name</>\n\nThe [removeListeners()</> method has been renamed to [disconnect()</>.\n"),this.disconnect()},resize:C.bind(null,"Window resize","resize",s),moveToAnchor(e){C("Move to anchor",`moveToAnchor:${e}`,s)},sendMessage(e){C("Send Message",`message:${e=JSON.stringify(e)}`,s)}};z[s].iframe.iframeResizer=e,z[s].iframe.iFrameResizer=e}}()),t?.iFrameResizer};function D(){!1===document.hidden&&(u("document","Trigger event: Visibility change"),function(e,i){const t=e=>z[e]?.autoResize&&!z[e]?.firstRun;Object.keys(z).forEach((function(n){t(n)&&C(e,i,n)}))}("Tab Visible","resize"))}const H=(e=>{let i=!1;return function(){return i?void 0:(i=!0,Reflect.apply(e,this,arguments))}})((()=>{o(window,"message",k),o(document,"visibilitychange",D),window.iframeParentListener=e=>k({data:e,sameDomain:!0})}));switch(!0){case void 0===window.jQuery:f("","Unable to bind to jQuery, it is not available.");break;case!window.jQuery.fn:f("","Unable to bind to jQuery, it is not fully loaded.");break;case window.jQuery.fn.iframeResize:f("","iframeResize is already assigned to jQuery.fn.");break;default:window.jQuery.fn.iframeResize=function(e){const i=A(e);return this.filter("iframe").each(i).end()},window.jQuery.fn.iFrameResize=function(e){return f("","Deprecated:  Use the iframeResize method instead of iFrameResize"),this.iframeResize(e)}}}));
//# sourceMappingURL=index.umd.js.map
